from django.urls import path, re_path
from . import views

app_name = 'metabaseBrowser'

urlpatterns = [
    re_path(r'^$',
    views.browser,
    name='browser'),
    re_path(r'^project/get_list$',
    views.get_project_list,
    name='get_project_list'),

    re_path(r'^project(?:/(?P<project_id>[0-9]+))?/$',
    views.browse_project,
    name='browse_project'),
    re_path(r'^project/(?P<project_id>[0-9]+)/init-tree$',
        views.init_project_tree_view,
        name='init_project_tree_view'),
    re_path(r'^project/(?P<project_id>[0-9]+)/sample/get-list$',
    views.SampleListView.as_view(),
    name='get_samples_list'),
    re_path(r'^project/(?P<project_id>[0-9]+)/sample/get-header$',
    views.get_qualifiers,
    name='get_qualifiers'),
    re_path(r'^project/[0-9]+/sample/(?P<sample_id>[0-9]+)/tree-view$',
    views.add_sample_tree_view,
    name='add_sample_tree_view'),
    re_path(r'^project/[0-9]+/sample/(?P<sample_id>[0-9]+)/init-tree$',
    views.init_sample_tree_view,
    name='init_sample_tree_view'),

    re_path(r'^tree-view/project/(?P<project_id>[0-9]+)/get-children',
        views.get_project_children,
        name="get_project_children"),
    re_path(r'^tree-view/tube/(?P<tube_id>[0-9]+)/get-children',
        views.get_tubes_children,
        name="get_tube_children"),
    re_path(r'^tree-view/tube/(?P<tube_id>[0-9]+)/get-libraries',
        views.get_libraries,
        name="get_libraries"),
    re_path(r'^tree-view/tube/(?P<tube_id>[0-9]+)/get-plates',
        views.get_plates,
        name="get_plates"),
    re_path(r'^tree-view/library/(?P<library_id>[^/]+)/get-children',
        views.get_library_children,
        name="get_library_children"),
    re_path(r'^tree-view/sample/(?P<sample_id>[0-9]+)/get-children',
        views.get_sample_children,
        name="get_sample_children"),
    re_path(r'^tree-view/extract/(?P<extract_id>[0-9]+)/get-children',
        views.get_extract_children,
        name="get_extract_children"),

    re_path(r'plate/(?P<plate_id>[0-9]+)/init-plate$',
        views.init_plate_view,
        name='init_plate_view'),
    ]
